import { HttpClientConfigData, IHttpClient } from "./contracts";
import request = require("request");
import bunyan = require("bunyan");
import { HttpVerb } from "./http-verb";
export declare class HttpClient implements IHttpClient {
    protected cfg: HttpClientConfigData;
    protected logger: bunyan;
    protected defaultTimeout: number;
    constructor(cfg: HttpClientConfigData, logger: bunyan);
    get<T>(urlPath: string, callback: (err: Error, response: T, statusCode: number) => void): void;
    delete<T>(urlPath: string, callback: (err: Error, data: T, statusCode: number) => void): void;
    post(requestData: any, urlPath: string, callback: (err: Error, body: any, statusCode: number) => void, async?: boolean, contentType?: string): void;
    postMultipart(requestData: any, urlPath: string, callback: (err: Error, body: any, statusCode: number) => void): void;
    private invokeHttpRequest;
    protected createOnRequestCallback(httpVerb: HttpVerb, requestId: string, callback: (err: Error, body: any, statusCode: number) => void): (err: any, requestResponse: any, body: any) => void;
    private allowUntrustedCertificates;
    protected createDefaultOptions(urlPath: string, contentType?: string): request.OptionsWithUrl;
    protected getDefaultTimeout(): number;
}
